#! /usr/bin/ruby

require 'digest/sha2'

sha256info = []
while line = gets
  case line
  when /^X-Ruby-CVS-SHA256Info: (.+), (.+), (.+)$/
    sha256info << {:file=>$1, :rev=>$2, :sha256=>$3}
  when /^X-Ruby-CVS-Template: (.+)/
    t = $1
    ARGF.close
  end
end

for m in sha256info
  cmd = format t, 'cvs', m[:rev], m[:file]
  raise "Dangerous charcters contained." if /[;\|<>*?&$()`\n]/ =~ cmd
  print m[:file], Digest::SHA256.hexdigest(`#{cmd}`) == m[:sha256] ?
    ": OK\n" :
    ": NG\n"
end
